<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>GTSBox: /Users/dlekshmi/Desktop/Repos/PhD/GTSBox/Projects/Transfection2018/UserFns/sampleSinglecellEstimates.m Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">GTSBox
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_7a6499598ddcfcabe96e224cb4a6d834.html">Projects</a></li><li class="navelem"><a class="el" href="../../dir_947b0bade59f2ec1a3d6dcc5254e948b.html">Transfection2018</a></li><li class="navelem"><a class="el" href="../../dir_7a5ad7d5dca3599a31868c2bbca96b8c.html">UserFns</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">sampleSinglecellEstimates.m</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../df/d85/_transfection2018_2_user_fns_2sample_singlecell_estimates_8m.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;%</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;% @brief SampleSinglecellEstimates samples the parameters of a single cell <span class="keyword">using</span> PESTO</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;% toolbox </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;% @params singlecell_estimates structure of single cell estimates of one</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;% cell</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;% @params nsamples number of samples</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;% @retva; singlecell_estimates the structre is appended with the</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;% distribution and sampling results</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="../../df/d85/_transfection2018_2_user_fns_2sample_singlecell_estimates_8m.html#af1c077c6209251e34d80064d0eae2d80">   10</a></span>&#160;<span class="keyword">function</span> [parameters]=<a class="code" href="../../df/df5/_llamosi2016_2_user_fns_2sample_singlecell_estimates_8m.html#af1c077c6209251e34d80064d0eae2d80">sampleSinglecellEstimates</a>(singlecell_estimates,nsamples,Model)</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;% uncomment <span class="keyword">this</span> part <span class="keywordflow">if</span> running stand alone</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;% addpath(genpath(<span class="stringliteral">&#39;../../Dependencies&#39;</span>))</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;% addpath(genpath(<span class="stringliteral">&#39;./UserFns&#39;</span>))</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;% addpath(genpath(<span class="stringliteral">&#39;../../Src/NLME/&#39;</span>))</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;% addpath(genpath(<span class="stringliteral">&#39;./&#39;</span>))</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;% load results from the first stage</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;% load(<span class="stringliteral">&#39;./ResultsNLME/AR_pool_1_Result_Transfection2018_Data_deGFP.mat&#39;</span>)</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;% Seed random number generator</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;rng(0);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;% data</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;data_cell=singlecell_estimates.dat;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;texp=singlecell_estimates.t;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;ind_est=singlecell_estimates.params;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;Hessian_est=singlecell_estimates.Hessian;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;int_opts=singlecell_estimates.int_opts;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;sigma_y=singlecell_estimates.measurement_sd;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;data_cell.time=texp;</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;%% Generation of the structs and options <span class="keywordflow">for</span> PESTO</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;% parameters</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;% display(<span class="stringliteral">&#39; Prepare structs and options...&#39;</span>)</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;parameters.name   = Model.indParams.namePars;</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;parameters.min    = Model.indParams.lowerbounds;</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;parameters.max    = Model.indParams.upperbounds;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;parameters.number = length(parameters.name);</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;% objective function</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;objectiveFunction = @(para) 2*(<a class="code" href="../../d9/d31/_llamosi2016_2_user_fns_2sample_w_o_l_s_8m.html#a3162c9ca8db18e728617e0f6a1e154ef">sampleWOLS</a>(data_cell.time,para,sigma_y,[],data_cell,int_opts));</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;% PestoOptions</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;optionsPesto           = PestoOptions();</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;optionsPesto.obj_type  = &#39;log-posterior&#39;;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;optionsPesto.comp_type = &#39;sequential&#39;;</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;optionsPesto.plot_options.add_points.par = ind_est;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;optionsPesto.plot_options.add_points.logPost = objectiveFunction(ind_est);</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;%% Parameter Sampling</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;% Covering all sampling options in one struct</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;% display(&#39; Sampling without prior information...&#39;);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;optionsPesto.MCMC.nIterations  = nsamples;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;% PT (with only 1 chain -&gt; AM) specific options:</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;optionsPesto.MCMC.samplingAlgorithm = &#39;PT&#39;;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;optionsPesto.MCMC.PT.nTemps         = length(ind_est);</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;optionsPesto.MCMC.PT.exponentT      = 6;</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;optionsPesto.MCMC.PT.regFactor      = 1e-8;</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;% Initialize the chains by choosing an initial point and a &#39;large&#39;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;% covariance matrix</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;optionsPesto.MCMC.theta0 = ind_est&#39;;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;optionsPesto.MCMC.sigma0 = 1e5 * eye(length(ind_est));</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;% Run the sampling</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;parameters = getParameterSamples(parameters, objectiveFunction, optionsPesto);</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;% Use a diagnosis tool to see, how plotting worked (see burn-in etc.)</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;% plotMCMCdiagnosis(parameters, &#39;parameters&#39;);</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;% %% Calculate Confidence Intervals</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;% Confidence Intervals for the Parameters are inferred from the local</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;% optimization and the sampling information.</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;% Set confidence levels</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;confLevels = [0.8, 0.9, 0.95, 0.99];</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;% display(&#39; Computing confidence intervals...&#39;);</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;parameters = getParameterConfidenceIntervals(parameters, confLevels, optionsPesto);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160; </div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;end </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;%% Perform another sampling</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;% optionsPesto.MCMC.theta0 = Model.indParams.inits&#39;;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;% optionsPesto.MCMC.sigma0 = 1e5 * eye(length(ind_est));</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;% parametersNew =parameters; % or another starting value </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;% parametersNew = getParameterSamples(parametersNew, objectiveFunction, optionsPesto);</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;%% </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160; </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="a_llamosi2016_2_user_fns_2sample_singlecell_estimates_8m_html_af1c077c6209251e34d80064d0eae2d80"><div class="ttname"><a href="../../df/df5/_llamosi2016_2_user_fns_2sample_singlecell_estimates_8m.html#af1c077c6209251e34d80064d0eae2d80">sampleSinglecellEstimates</a></div><div class="ttdeci">function sampleSinglecellEstimates(in singlecell_estimates, in nsamples, in Model)</div><div class="ttdoc">%&gt;</div></div>
<div class="ttc" id="a_llamosi2016_2_user_fns_2sample_w_o_l_s_8m_html_a3162c9ca8db18e728617e0f6a1e154ef"><div class="ttname"><a href="../../d9/d31/_llamosi2016_2_user_fns_2sample_w_o_l_s_8m.html#a3162c9ca8db18e728617e0f6a1e154ef">sampleWOLS</a></div><div class="ttdeci">function sampleWOLS(in t, in kinetic_params, in measurement_noise, in pop_params, in d, in int_opts)</div><div class="ttdoc">%&gt;</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Dec 3 2020 14:53:29 for GTSBox by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
